package ru.dbotthepony.mc.otm.tests

import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.mc.otm.network.FieldSynchronizer
import java.io.ByteArrayInputStream

object FieldSynchronizerTests {
	@Test
	@DisplayName("Field Synchronizer full read/write test")
	fun test() {
		val a = FieldSynchronizer()
		val b = FieldSynchronizer()

		val boolA = a.bool()
		val boolB = b.bool()

		val intA = a.int()
		val intB = b.int()

		val intA2 = a.int()
		val intB2 = b.int()

		val intA3 = a.int()
		val intB3 = b.int()

		boolA.value = true
		intA.value = 8384
		intA2.value = 348488
		intA3.value = -4

		b.applyNetworkPayload(a.collectNetworkPayload()!!.let { ByteArrayInputStream(it.array, 0, it.length) })

		assertEquals(boolA.value, boolB.value)
		assertEquals(intA.value, intB.value)
		assertEquals(intA2.value, intB2.value)
		assertEquals(intA3.value, intB3.value)
	}

	@Test
	@DisplayName("Field Synchronizer partial read/write test")
	fun testPartial() {
		val a = FieldSynchronizer()
		val b = FieldSynchronizer()

		val boolA = a.bool()
		val boolB = b.bool()

		val intA = a.int()
		val intB = b.int()

		val intA2 = a.int()
		val intB2 = b.int()

		val intA3 = a.int()
		val intB3 = b.int()

		boolA.value = true
		//intA.setValue(8384)
		//intA2.setValue(348488)
		intA3.value = -4

		b.applyNetworkPayload(a.collectNetworkPayload()!!.let { ByteArrayInputStream(it.array, 0, it.length) })

		assertEquals(boolA.value, boolB.value)
		assertEquals(intA.value, intB.value)
		assertEquals(intA2.value, intB2.value)
		assertEquals(intA3.value, intB3.value)
	}
}
